// -- FONTS

/// Declare a font-face
///
/// @param string  $font-family   Using name of font
/// @param string  $name          Filename of font file
/// @param string  $weight        Weight of font (100, 200, normal, bold, etc.) [optional]
/// @param string  $style         Style of font (normal, italic, etc.) [optional]
/// @param bool    $woff2         If font is woff2 format [optional]
/// @output Font-face
///
@mixin font-face($font-family, $name, $weight: normal, $style: normal, $woff2: false) {
  $file-path: $path-font + $name;
  @font-face {
    font-display: swap;
  font-family: $font-family;
  font-weight: $weight;
  font-style: $style;
    src:
      url('#{$file-path}.eot?#iefix') format('embedded-opentype'),
      url('#{$file-path}.ttf') format('truetype'),
      url('#{$file-path}.svg#DINCond-Bold') format('svg'),
      url('#{$file-path}.woff') format('woff');
  }
}
/// Display font-size in rem + fallback for IE
///
/// @param number  $size    Value in pixel to transform to rem
/// @output Font size in rem + fallback
///
@mixin font-size($size: 16) {
  font-size: $size + px; //fallback for old browsers
  font-size: (0.0625 * $size) + rem; // base 16 // html
}

// -- ICONS

@mixin icon {
  /* use !important to prevent issues with browser extensions that change fonts */
  font-family: $font-family-icons !important;
  speak: none;
  font-style: normal;
  font-weight: normal;
  font-variant: normal;
  text-transform: none;
  line-height: 1;
  text-indent: 0;

  /* Better Font Rendering =========== */
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
}

/// Fetch content by icon name
///
/// @param {string} $name Name of icon
/// @return {string} Unicode of icon
@function icon($name) {
  @each $icon in $icons {
  @if $name == nth($icon, 1) {
    @return nth($icon, 2);
  }
  }
}

// Create master class .icon
%icon {
  @include icon;
}

@mixin use-icon($icon) {
  @extend %icon;
  content: icon($icon);
}

// workaround for @extend across media queries
@mixin use-icon-mq($icon) {
  @include icon;
  content: icon($icon);
}

/// Make icons class
///
/// @output Icon class
@mixin make-icons {
  @each $icon in $icons {
  .icon-#{nth($icon, 1)} {
    &:before {
    content: nth($icon, 2);
    }
  }
  }
}

// -- RESPONSIVE

/// Create a media-query
///
/// @output Media query
///
@mixin mq($media-string: false, $print: false) {
  @if $media-string != false {
  @media only screen and #{$media-string} {
    @content;
  }
  }

  @if $print != false {
  @media only print {
    @content;
  }
  }
}

/// Create Media Query for max or/and min
///
/// @param {bool|string} $max Max size
/// @param {string} $min Min size [optional]
/// @output Media Query
///
@mixin mq-size($max: false, $min: 'max') {
  $media-string: '';

  @if $max != false {
  @if $min == 'min' {
    $media-string: '(min-width: #{$max})';
  } @else if $min == 'max' {
    $media-string: '(max-width: #{$max})';
  } @else {
    $media-string: '(min-width: #{$min}) and (max-width: #{$max})';
  }

  @include mq ($media-string) {
    @content;
  }
  }
}

/// Create Media Query for breakpoint
///
/// @param {string|number} $size Breakpoint
/// @param {string|bool} $opts Option (only, min, false) [optional, default=false]
/// @param {bool} $print Only for print [optional, default=false]
/// @param {array} $list List of breakpoints [optional, default=$flexboxgrid-breakpoints]
/// @output Media Query
///
@mixin screen-size($size, $opts: max, $print: false, $list: $breakpoints) {
  $media-string: false;
  $min: 0;

  @each $breakpoint in $list {
  @if $size == nth($breakpoint, 1) {
    @if $opts == only {
    $media-string: '(min-width: #{$min}) and (max-width: #{nth($breakpoint, 2) - 1})';
    } @else if $opts == min {
    $media-string: '(min-width: #{nth($breakpoint, 2)})';
    } @else {
    $media-string: '(max-width: #{nth($breakpoint, 2) - 1})';
    }
  } @else {
    $min: nth($breakpoint, 2);
  }
  }

  @include mq ($media-string, $print) {
  @content;
  }
}

// OLD CSS
@mixin breakmax($size) {
  @media all and (max-width: $size) {
    @content;
  }
}

// mixin for IE (and edge)
@mixin ie() {
  @media screen and (-ms-high-contrast: active), (-ms-high-contrast: none) {
  @content;
  }
}

// To use when page is printing
@mixin print() {
  @media print {
  @content;
  }
}

// --- Helpers

/// Clearfix (micro version)
/// @see http://nicolasgallagher.com/micro-clearfix-hack/
/// @output Clearfix

@mixin clearfix {
  &:after {
  content: " ";
  display: table;
  clear: both;
  }
  .lte-ie7 & {
  zoom: 1;
  }
}

//------ SASS Useful Mixins ---------------------------------------------

// by Ryan Burgess
// https://github.com/ryanburgess/SASS-Useful-Mixins
// MIT © Ryan Burgess

// -----------------------------------------------------------------------

// Linear Gradients

// ----------------------------------------------------------------------

// example: @include linearGradient(#cccccc, #333333);

@mixin linearGradient($top, $bottom) {
  background: #{$top}; /* Old browsers */
  background:    -moz-linear-gradient(top, #{$top} 0%, #{$bottom} 100%); /* FF3.6+ */
  background:        -webkit-gradient(linear, left top, left bottom, color-stop(0%, #{$top}), color-stop(100%, #{$bottom})); /* Chrome,Safari4+ */
  background: -webkit-linear-gradient(top, #{$top} 0%, #{$bottom} 100%); /* Chrome10+,Safari5.1+ */
  background:      -o-linear-gradient(top, #{$top} 0%, #{$bottom} 100%); /* Opera 11.10+ */
  background:     -ms-linear-gradient(top, #{$top} 0%, #{$bottom} 100%); /* IE10+ */
  background:         linear-gradient(to bottom, #{$top} 0%, #{$bottom} 100%); /* W3C */
  filter: progid:DXImageTransform.Microsoft.gradient( startColorstr='#{$top}', endColorstr='#{$bottom}', GradientType=0 ); /* IE6-9 */
}

// Transition

// ----------------------------------------------------------------------

// example: @include transition(all .2s ease);
@mixin transition($args...) {
  -webkit-transition: $args;
  -moz-transition: $args;
  -ms-transition: $args;
  -o-transition: $args;
  transition: $args;
}


// Border Radius

// ----------------------------------------------------------------------

// example: @include borderRadius(2px);
@mixin borderRadius($args...) {
  -webkit-border-radius: $args;
  -moz-border-radius: $args;
  border-radius: $args;
}


@mixin transform($transforms) {
     -moz-transform: $transforms;
       -o-transform: $transforms;
      -ms-transform: $transforms;
  -webkit-transform: $transforms;
          transform: $transforms;
}
// rotate
@mixin rotate($deg) {
  @include transform(rotate(#{$deg}deg));
}
// translate
@mixin translate($x, $y) {
   @include transform(translate($x, $y));
}

@mixin overflowScroll() {
    overflow: scroll;
    -webkit-overflow-scrolling: touch;
}

@mixin placeholderColor($color) {
  ::-webkit-input-placeholder { /* Chrome/Opera/Safari */
    color: $color;
  }
  ::-moz-placeholder { /* Firefox 19+ */
    color: $color;
  }
  :-ms-input-placeholder { /* IE 10+ */
    color: $color;
  }
  :-moz-placeholder { /* Firefox 18- */
    color: $color;
  }
}

// OLD CSS
@mixin input-placeholder {
  ::-webkit-input-placeholder {
    @content
  }
  :-moz-placeholder {
    @content
  }
  ::-moz-placeholder {
    @content
  }
  :-ms-input-placeholder {
    @content
  }
}
